#include <linux/stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include "hopping_matrix.h"
#include "tile.h"
#define INPUT1 2450432
#define INPUT2 108304

/*MA FONCTION A MODIFIER*/
/* l output , k input*/
/* for ieo=0, k resides on  odd sites and l on even sites */
void Hopping_Matrix(const int ieo, spinor * const l, spinor * const k){
   int i,ix, j, z;
   /*  int Vov2or0; */ /* ZL */
   su3 * restrict iU ; /* ZL */
   spinor * restrict s ;
   su3_vector psi, chi;
   halfspinor * restrict * phi ;

   time_t current;

   su3 * restrict save_iU ; /* ZL */
   spinor * restrict save_s ;
   int save_ix;

#ifdef _KOJAK_INST
#pragma pomp inst begin(hoppingmatrix)
#endif
#ifdef XLC
#pragma disjoint(*l, *k, *U, *s);
#endif

   if(HM_cpt>INPUT1){
      printf("ERREUR! je suis passe dans la fonction plus de %d fois!!!!\n", INPUT1);
      exit(-1);
   }


   if(k == l){
      printf("Error in H_psi (simple.c):\n");
      printf("Arguments k and l must be different\n");
      printf("Program aborted\n");
      exit(1);
   }
   s = k;


    current=time((time_t *)0);


    HM_cpt++;

#pragma omp parallel num_threads(NBT)
{
#pragma omp for private(j,phi,iU)  
   for(j=0; j<(VOLUME)/2; j+=TILE){
    
     s = k;

     if(ieo == 0) {
       iU = g_gauge_field_copy2[0]; /* ZL */
     }
     else {
       iU = g_gauge_field_copy2[0]+VOLUME/2; /* ZL */
     }
    
    s+=j;
    iU+=j;

    phi = NBPointer[ieo];
    save_s = s;
    save_iU = iU;    
  
    /**************** loop over all lattice sites ****************/
    ix=j*2;
    int TILED;
#pragma xlang begin
    for(i = 0; i < TILED; i++){
      /*********************** direction +0 ************************/
      
      _vector_add(psi, (*s).s0, (*s).s2);

      _su3_multiply(chi,(*iU),psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s0, ka0, chi);
      
            
      iU=iU+1; /* ZL */
      /*********************** direction -0 ************************/

      _vector_sub((*phi[ix+1+i*2]).s0, (*s).s0, (*s).s2);

      s=s+1;
      /************* compensation of other directions **************/
    }  
    #pragma xlang parameter TILED [128,256,512]
    #pragma xlang parameter Ui [1,2,4]
    #pragma xlang transform unroll(i,Ui)
    //#pragma xlang transform fission(i)
    //#pragma xlang transform decompose(1)
#pragma xlang end
    s = save_s;
    iU = save_iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +0 ************************/

      _vector_add(psi, (*s).s1, (*s).s3);

      _su3_multiply(chi,(*iU),psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s1, ka0, chi);

      iU++; /* ZL */
      /*********************** direction -0 ************************/

      _vector_sub((*phi[ix+1+i*2]).s1, (*s).s1, (*s).s3);

      s++;
      /************* compensation of other directions **************/
    }

    ix+=VOLUME;

    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[1]; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[1]+VOLUME/2; /* ZL */
    }
 
    s+=j;
    iU+=j;

    save_s = s;
    save_iU = iU;

    /**************** loop over all lattice sites ****************/
    for(i = 0; i < TILE; i++){
      /*********************** direction +1 ************************/

      _vector_i_add(psi, (*s).s0, (*s).s3);

      _su3_multiply(chi, (*iU), psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s0, ka1, chi);

      iU++; /* ZL */

      /*********************** direction -1 ************************/

      _vector_i_sub((*phi[ix+1+i*2]).s0, (*s).s0, (*s).s3);

      /************* compensation of other directions **************/
      s++;
    }  
    s = save_s;
    iU = save_iU;


    for(i = 0; i < TILE; i++){
      /*********************** direction +1 ************************/

      _vector_i_add(psi, (*s).s1, (*s).s2);

      _su3_multiply(chi, (*iU), psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s1, ka1, chi);

       iU++;
      /*********************** direction -1 ************************/

      _vector_i_sub((*phi[ix+1+i*2]).s1, (*s).s1, (*s).s2);

      /************* compensation of other directions **************/
      s++;
    }

    ix+=VOLUME;

    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[2]; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[2]+VOLUME/2; /* ZL */
    }
    /**************** loop over all lattice sites ****************/

    s+=j;
    iU+=j;

    save_s = s;
    save_iU = iU;


    for(i = 0; i < TILE; i++){
      /*********************** direction +2 ************************/

      _vector_add(psi, (*s).s0, (*s).s3);

      _su3_multiply(chi,(*iU),psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s0, ka2, chi);

      _vector_sub((*phi[ix+1+i*2]).s0, (*s).s0, (*s).s3);
      /************* compensation of other directions **************/
       iU++;
       s++;

    }  
   
    s=save_s;
    iU=save_iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +2 ************************/


      _vector_sub(psi, (*s).s1, (*s).s2);

      _su3_multiply(chi,(*iU),psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s1, ka2, chi);

      iU++;
      /*********************** direction -2 ************************/

      _vector_add((*phi[ix+1+i*2]).s1, (*s).s1, (*s).s2);
      s++;
      /************* compensation of other directions **************/
    }

   ix+=VOLUME;

    s=k;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[3]; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[3]+VOLUME/2; /* ZL */
    }
    /**************** loop over all lattice sites ****************/

    s+=j;
    iU+=j;

    save_s=s;
    save_iU=iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +3 ************************/

      _vector_i_add(psi, (*s).s0, (*s).s2);
      
      _su3_multiply(chi, (*iU), psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s0, ka3, chi);


      iU++; /* ZL */
      /*********************** direction -3 ************************/

      _vector_i_sub((*phi[ix+1+i*2]).s0, (*s).s0, (*s).s2);

      s++;
      /************************ end of loop ************************/
    }

    s=save_s;
    iU=save_iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +3 ************************/

      _vector_i_sub(psi, (*s).s1, (*s).s3);

      _su3_multiply(chi,(*iU),psi); /* ZL */
      _complex_times_vector((*phi[ix+i*2]).s1, ka3, chi);

      iU++; /* ZL */
      /*********************** direction -3 ************************/

      _vector_i_add((*phi[ix+1+i*2]).s1, (*s).s1, (*s).s3);

      s++;
      /************************ end of loop ************************/
    }
   
  }
}

#    if (defined MPI && !defined _NO_COMM)
    xchange_halffield(); 
#    endif
     
#pragma omp parallel num_threads(NBT)
{
#pragma omp for private(j, iU, phi)
   
   for(j=0; j<(VOLUME)/2; j+=TILE){
    
    s = l;
    phi = NBPointer[2 + ieo];
    if(ieo == 0) {
      iU = g_gauge_field_copy2[0]+VOLUME/2; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[0]; /* ZL */
    }

    ix = j*2;

    s+=j;
    iU+=j;  

    save_s=s;
    save_iU=iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +0 ************************/
      /*********************** direction -0 ************************/
      _su3_inverse_multiply(chi,(*iU),(*phi[ix+1+i*2]).s0); /* ZL */
      _complexcjg_times_vector(psi,ka0,chi);

      _vector_add((*s).s0, (*phi[ix+i*2]).s0, psi);
      _vector_sub((*s).s2, (*phi[ix+i*2]).s0, psi);
      iU++;
      s++;
    }

    s = save_s;
    iU = save_iU;

    for(i = 0; i < TILE; i++){

      _su3_inverse_multiply(chi,(*iU),(*phi[ix+1+i*2]).s1); /* ZL */
      _complexcjg_times_vector(psi,ka0,chi);
      
      _vector_add((*s).s1, (*phi[ix+i*2]).s1, psi);
      _vector_sub((*s).s3, (*phi[ix+i*2]).s1, psi);
      iU++; /* ZL */
      s++;
      /************* compensation of other directions **************/
    } 

    ix+=VOLUME;

    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[1]+VOLUME/2; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[1]; /* ZL */
    }

    s+=j;
    iU+=j;

    save_s = s;
    save_iU = iU;    


    for(i = 0; i < TILE; i++){
      /*********************** direction +1 ************************/

      _vector_add_assign((*s).s0, (*phi[ix+i*2]).s0);
      _vector_i_sub_assign((*s).s3, (*phi[ix+i*2]).s0); 
      /*********************** direction -1 ************************/

      _su3_inverse_multiply(chi,(*iU), (*phi[ix+1+i*2]).s0); /* ZL */
      _complexcjg_times_vector(psi,ka1,chi);

      _vector_add_assign((*s).s0, psi);  /* ZL */
      _vector_i_add_assign((*s).s3, psi);

      iU++; /* ZL */
      s++;
      /************* compensation of other directions **************/
    } 

    s = save_s;
    iU = save_iU;


    for(i = 0; i < TILE; i++){
      /*********************** direction +1 ************************/

      _vector_add_assign((*s).s1, (*phi[ix+i*2]).s1);
      _vector_i_sub_assign((*s).s2, (*phi[ix+i*2]).s1);

      /*********************** direction -1 ************************/

      _su3_inverse_multiply(chi,(*iU),(*phi[ix+1+i*2]).s1); /* ZL */
      _complexcjg_times_vector(psi,ka1,chi);

      _vector_add_assign((*s).s1, psi);  /* ZL */
      _vector_i_add_assign((*s).s2, psi);

      iU++; /* ZL */
      s++;
      /************* compensation of other directions **************/
    }

    ix+=VOLUME;

    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[2]+VOLUME/2; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[2]; /* ZL */
    }

    s+=j;
    iU+=j;

    save_s=s;
    save_iU=iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +2 ************************/

      _vector_add_assign((*s).s0, (*phi[ix+i*2]).s0);
      _vector_add_assign((*s).s3, (*phi[ix+i*2]).s0);

      /*********************** direction -2 ************************/

      _su3_inverse_multiply(chi,(*iU), (*phi[ix+1+i*2]).s0); /* ZL */
      _complexcjg_times_vector(psi,ka2,chi);

      _vector_add_assign((*s).s0, psi);  /* ZL */
      _vector_sub_assign((*s).s3, psi);

      iU++; /* ZL */
      s++;
      /************* compensation of other directions **************/
    } 
   
    s=save_s;
    iU=save_iU;


    for(i = 0; i < TILE; i++){
      /*********************** direction +2 ************************/

      _vector_add_assign((*s).s1, (*phi[ix+i*2]).s1);
      _vector_sub_assign((*s).s2, (*phi[ix+i*2]).s1);

      /*********************** direction -2 ************************/

      _su3_inverse_multiply(chi, (*iU), (*phi[ix+1+i*2]).s1); /* ZL */
      _complexcjg_times_vector(psi,ka2,chi);

      _vector_add_assign((*s).s1, psi);  /* ZL */
      _vector_add_assign((*s).s2, psi);  /* ZL */

      iU++; /* ZL */
      s++;
      /************* compensation of other directions **************/
    }

    ix+=VOLUME;

    s = l;
    if(ieo == 0) {
      iU = g_gauge_field_copy2[3]+VOLUME/2; /* ZL */
    }
    else {
      iU = g_gauge_field_copy2[3]; /* ZL */
    }

    s+=j;
    iU+=j;

    save_s=s;
    save_iU=iU;

    for(i = 0; i < TILE; i++){
      /*********************** direction +3 ************************/

      _vector_add_assign((*s).s0, (*phi[ix+i*2]).s0);
      _vector_i_sub_assign((*s).s2, (*phi[ix+i*2]).s0);

      /*********************** direction -3 ************************/

      _su3_inverse_multiply(chi,(*iU), (*phi[ix+1+i*2]).s0); /* ZL */
      _complexcjg_times_vector(psi,ka3,chi);
      
      _vector_add_assign((*s).s0, psi); /* ZL */
      _vector_i_add_assign((*s).s2, psi); /* ZL */

      iU++; /* ZL */
      s++;
    }  /* end of volume loop */

    s=save_s;
    iU=save_iU;


    for(i = 0; i < TILE; i++){
      /*********************** direction +3 ************************/

      _vector_add_assign((*s).s1, (*phi[ix+i*2]).s1);
      _vector_i_add_assign((*s).s3, (*phi[ix+i*2]).s1);

      /*********************** direction -3 ************************/

      _su3_inverse_multiply(chi,(*iU), (*phi[ix+1+i*2]).s1); /* ZL */
      _complexcjg_times_vector(psi,ka3,chi);

      _vector_add_assign((*s).s1, psi); /* ZL */
      _vector_i_sub_assign((*s).s3, psi); /* ZL */

      iU++; /* ZL */
      s++;
    } 
   }

 }

current=time((time_t *)0)-current;
global+=current;

  /* precision */
#ifdef _KOJAK_INST
#pragma pomp inst end(hoppingmatrix)
#endif
}
